
function Socket(host, port) {
	
	this.transport = null;
	this.host = host;
	this.port = port;
	
	try {
		var tranService = Components.classes["@mozilla.org/network/socket-transport-service;1"]
								.getService(Components.interfaces.nsISocketTransportService);
		
		this.transport = tranService.createTransport(null,0,host,port,null);
	} catch(e) {
		throw e;
	}
	
	
	/**
	 * 
	 */
	this.close = function () {
		result = {};
		
		try {
			this.transport.close(result);
		} catch(e) {
			throw e;
		}
		
		return result;
	}
	
	/**
	 * 
	 */
	this.getInputStream = function() {
		var is = null;
		
		try {
			is = this.transport.openInputStream(0,0,0);
		} catch(e) {
			throw e;
		}
		
		return is;
	}
	
	
	/**
	 * 
	 * @param {Object} charset
	 */
	this.getConverterInputStream = function(charset) {
		var conin = null;
		
		try {
			var is = this.getInputStream();
			
			const replacementChar = Components.interfaces.nsIConverterInputStream.DEFAULT_REPLACEMENT_CHARACTER;
			
			conin = Components.classes["@mozilla.org/intl/converter-input-stream;1"]
						.createInstance(Components.interfaces.nsIConverterInputStream);
			
			conin.init(is, charset, 1024, replacementChar);
		} catch(e) {
			throw e;
		}
		
		return conin;
	}
	
	/**
	 * 
	 */
	this.getOutputStream = function() {
		var out = null;
		
		try {
			out = this.transport.openOutputStream(0,0,0);	
		} catch(e) {
			throw e;
		}
		
		return out;
	}
	
	/**
	 * 
	 * @param {Object} charset
	 */
	this.getConverterOutputStream = function(charset) {
		var conout = null;
		
		try {
			var out = this.getOutputStream();
			
			conout = Components.classes["@mozilla.org/intl/converter-output-stream;1"]
							.createInstance(Components.interfaces.nsIConverterOutputStream);
						
		    conout.init(out, charset, 0, 0x0000);
	    } catch(e) {
	    	throw e;
	    }
	    
	    return conout;
	}
}