
function PostHistory(threadName) {
	
	//定数
	this.FILE_NAME = "_history";
	this.MAX_SIZE = 250;
	
	this.file = null;
	this.postHistoryList = new Array();
	this.postHistoryDic = null;
	
	//-------------------------------
	try {
		var logRoot = getMoonfoxLogRoot();
		var dir = null;
		
		if(logRoot && logRoot.exist())
			dir = new File(logRoot, threadName);
		
		if(dir && dir.exist())
			this.file = new File(dir, this.FILE_NAME);
		
		if(this.file && this.file.exist()) {
			var is = this.file.establishConverterInputStream("UTF-8");
			
			var size = this.file.size();
			var postHistoryStr = "";
			var strbuf = {};
			
			while(is.readString(size, strbuf) != 0) {
				postHistoryStr += strbuf.value;
				strbuf = {};
			}
			
			is.close();
			
			this.postHistoryList = postHistoryStr.split(",");
		}
	} catch(e) {
		throw e;
	}
	//----------------------------------
	/**
	 * historyに追加します。
	 * @param {Object} recordList
	 */
	this.append = function(recordList) {
		if(!recordList || recordList.length == 0)
			return;
		
		//含まれていなければ追加
		for(var i = 0; i < recordList.length; i++) {
			if( !this.contain(recordList[i]) ) {
				this.postHistoryList.unshift(recordList[i].id);
			}
		}
		
		//最大保持数を越えたらスライス
		if(this.postHistoryList.length > this.MAX_SIZE) {
			this.postHistoryList = this.postHistoryList.slice(0, this.MAX_SIZE);
		}
		
		//書き出す
		var out = this.file.establishConverterOutputStream("UTF-8");
		
		for(var i = 0; i < this.postHistoryList.length; i++) {
			out.writeString(this.postHistoryList[i]);
			
			if(i != this.postHistoryList.length - 1) {
				out.writeString(",");
			}
		}
		
		out.close();
	}
	
	/**
	 * historyに含まれていないレコードが1つでもある場合、trueを返します。
	 * @param {Object} recordFileList
	 */
	this.checkUnreadRecord = function(recordFileList) {
		var unread = false;
		
		for(var i = 0; i < recordFileList.length; i++) {
			var id = recordFileList[i].getName();
			
			if( !this.contain(id) ) {
				unread = true;
				break;
			}
		}
		
		return unread;
	}
	
	/**
	 * 
	 * @param {Object|string} record RecordオブジェクトかレコードのID
	 */
	this.contain = function(record) {
		var found = false;
		
		var id = "";
		
		if(typeof(record) == "string")
			id = record;
		else
			id = record.id;
		
		if(this.postHistoryList) {
			for(var i = 0; i < this.postHistoryList.length; i++) {
				if(id == this.postHistoryList[i]) {
					found = true;
					break;
				}
			}
		}
		
		return found;
	}
	
	/**
	 * 
	 */
	this.getLastStamp = function() {
		var stamp = "0";
		
		if(this.postHistoryList.length == 0)
			return stamp;
		
		stamp = this.postHistoryList[0].match(/^([0-9]+)\_.+/);
		
		return stamp;
	}
	
}