var deleteThreadArray = null;
var opt = null;

/*
 * 削除するスレッドのリストを生成します。
 */
function createDeleteList() {
	var box = document.getElementById("vbox_delete_list");
	
	for(var i = 0; i < deleteThreadArray.length; i++) {
		var chk = document.createElement("checkbox");
		chk.setAttribute("id", deleteThreadArray[i].file);
		chk.setAttribute("checked", "true");
		
		var str = deleteThreadArray[i].title
					+ " (" + deleteThreadArray[i].records 
					+ " / " + formatSizeStr(deleteThreadArray[i].size) + ")";
		
		if(!existCache(deleteThreadArray[i])) {
			str += " \"" + msg("I_01") + "\"";
			chk.setAttribute("class", "nocache");
			chk.setAttribute("checked", "false");
		}
		
		chk.setAttribute("label", str);
		
		box.appendChild(chk);
	}
}

/*
 * スレッド削除処理を行います。
 */
function deleteThread() {
	try {
		var array = new Array();
		
		for(var i = 0; i < deleteThreadArray.length; i++) {
			var chk = document.getElementById(deleteThreadArray[i].file);
			
			if(chk.checked && existCache(deleteThreadArray[i]))
				array.push(deleteThreadArray[i]);
		}
		
		if(array.length == 0) {
			alert(msg("W_01"));
			return;
		}
		
		//プログレスメータをスタート
		document.getElementById("progress").mode = "undetermined";
		document.getElementById("progress").hidden = false;
		
		//削除ボタンを押下不可に
		document.getElementById("btn_delete").disabled = true;
		
		prepareDelete(array);
	} catch(e) {
		alert(e);
	}
}

/*
 * cmd=xfdelでデータを送信し、レスポンスがあったときの処理を行います。
 *
 * @request
 */
function deleted(request) {
	opt.ok = true;
	
	//プログレスメータをストップ
	document.getElementById("progress").mode = "determined";
	document.getElementById("progress").hidden = true;
	
	setTimeout("close();", 10);
}

/*
 *
 */
function deleteError() {
	alert(msg("E_02"));
	
	//プログレスメータをストップ
	document.getElementById("progress").mode = "determined";
	document.getElementById("progress").hidden = true;
	
	//削除ボタンを押下可に
	document.getElementById("btn_delete").disabled = false;
}

/*
 * cmd=xfdelでデータを送信し、レスポンスがあったときの処理を行います。
 * 実際の削除処理。
 *
 * @request
 * @userData
 */
function executeDelete(sid, userData) {
	var array = userData.data;
	var data = "cmd=xfdel&";
	data += "sid=" + sid + "&";
	
	for(var i = 0; i < array.length; i++) {
		data += "file=" + array[i].file;
		
		if(i != array.length - 1)
			data += "&";
	}

	postDataToAdmin(deleted, deleteError, data, userData);
}

/*
 * cmd=fdelでデータを送信します。
 * 削除準備処理。
 *
 * @request
 * @userData
 */
function prepareDelete(array) {
	var data = "cmd=fdel&";
	
	for(var i = 0; i < array.length; i++) {
		data += "file=" + array[i].file;
		
		if(i != array.length - 1)
			data += "&";
	}
	
	var userData = {data:null};
	userData.data = array;
	postDataToAdmin(prepared, deleteError, data, userData);
}

/*
 * cmd=fdelでデータを送信し、レスポンスがあったときの処理を行います。
 *
 * @request
 * @userData
 */
function prepared(request, userData) {
	var res = request.responseText;
	
	if(res.match(/name\=\"sid\".+value\=\"(.+)\"/)) {
		var sid = RegExp.$1;
		executeDelete(sid, userData);
	} else {
		alert("Cannot find sid.");
	}
}

/*
 * 初期処理を行います。
 */
function startup() {
	try {
		initMsg("chrome://moonfox/locale/messages.properties");
		var target = null;
		
		opt = window.arguments[0];
		target = window.arguments[1];
		
		deleteThreadArray = target;
		
		createDeleteList();
	} catch(e) {
		alert(e);
	}
}