//定数
const PANE_PADDING = 25;
const THUMB_SPACE = 20;

//変数
var threadFileList = null;
var thumbSize = 150;
var paneWidth = 600;
var imgNumPerPage = 20;

function clearCache() {
	var classID = Components.classes["@mozilla.org/network/cache-service;1"];
	var cacheService = classID.getService(Components.interfaces.nsICacheService);
	//cacheService.evictEntries(Components.interfaces.nsICache.STORE_ON_DISK);
	//cacheService.evictEntries(Components.interfaces.nsICache.STORE_IN_MEMORY);
	cacheService.evictEntries(Components.interfaces.nsICache.STORE_ANYWHERE);
}

function configThumbPosition() {
	var pane = document.getElementById("stack_pane");
	
	//pane.style.width = paneWidth + "px";
	var colNum = (paneWidth - PANE_PADDING * 2) / (thumbSize + THUMB_SPACE);
	colNum = parseInt(colNum);
	
	if(colNum == 0)
		colNum = 1;
	
	var imgNodes = pane.childNodes;
	var rowCnt = 0;
	
	for(var i = 0; i < imgNodes.length; i += colNum) {
		
		for(var colCnt = 0; colCnt < colNum; colCnt++) {
			var left = PANE_PADDING + ((thumbSize + THUMB_SPACE) * colCnt);
			var top = PANE_PADDING + ((thumbSize + THUMB_SPACE) * rowCnt);
			
			if(imgNodes[i + colCnt]) {
				//imgNodes[i + colCnt].width = thumbSize;
				//imgNodes[i + colCnt].height = thumbSize;
				imgNodes[i + colCnt].setAttribute("left", parseInt(left));
				imgNodes[i + colCnt].setAttribute("top", parseInt(top));
				//imgNodes[i + colCnt].style.left = left + "px";
				//imgNodes[i + colCnt].style.top = top + "px";
			}
		}
		
		rowCnt += 1;
	}
}

function constructImage() {
	var pane = document.getElementById("stack_pane");
	
	for(var i = 0; i < imgNumPerPage; i++) {
		var img = document.createElement("image");
		img.setAttribute("id", "image_thumb_" + i);
		//img.setAttribute("src", null);
		img.setAttribute("width", thumbSize);
		img.setAttribute("height", thumbSize);
		img.style.borderWidth = "2px";
		img.left = 0;
		pane.appendChild(img);
	}
}

function constructThumbnail(fileList) {
	var pane = document.getElementById("stack_pane");
	
	//現在のサムネイルを削除
	while(pane.firstChild) {
		pane.firstChild.setAttribute("src", "");
		pane.removeChild(pane.firstChild);
	}
	
	//clearCache();
	
	//var attachDir = new File(thDir, "attach");
	//var attachFileList =  attachDir.listFile();
	
	if(!fileList || fileList.length == 0)
		return;
	//loadImage(fileList, 0, pane);
	
	for(var i = 0; i < 10; i++) {
		var file = fileList[i];
		
		if(!file)
			break;
			
		var ext = file.getExt();
		
		if(ext == "jpg" || ext == "png" || ext == "gif" || ext == "bmp") {
			var img = document.createElement("image");
			img.setAttribute("validate", "never");
			img.setAttribute("src", file.getUrlSpec());
			
			img.setAttribute("width", thumbSize);
			img.setAttribute("height", thumbSize);
			img.style.borderWidth = "2px";
			img.left = 0;
			pane.appendChild(img);
		}
	}
	
	configThumbPosition();
}

function endup() {
	
	var pane = document.getElementById("stack_pane");
	
	//現在のサムネイルを削除
	while(pane.firstChild) {
		var img = pane.firstChild;
		img.setAttribute("src", "");
		pane.removeChild(img);
	}
	
	clearCache();
}

function loadImage(fileList, index, pane) {
	var file = fileList[index];
	var ext = file.getExt();
	
	if(ext == "jpg" || ext == "png" || ext == "gif" || ext == "bmp") {
		var img = document.createElement("image");
		img.setAttribute("src", file.getUrlSpec());
		img.setAttribute("width", thumbSize);
		img.setAttribute("height", thumbSize);
		img.style.borderWidth = "2px";
		img.left = 0;
		pane.appendChild(img);
		
		if(index + 1 < fileList.length) {
			img.onload = function() {
				loadImage(fileList, index+1, pane);
			}
			
			img.onerror = function() {
				loadImage(fileList, index+1, pane);
			}
		}
	} else {
		if(index + 1 < fileList.length)
			loadImage(fileList, index + 1, pane);
	}
	
	configThumbPosition();
}

function setThumbSize(size) {
	thumbSize = size;
}

function startup() {
	try {
		constructThumbnail();
	} catch(e) {
		alert(e);
	}
}