
/*
 * 終了処理
 */
function endup() {
	try {
		setPref("moonfox.thread_tree_sort_category", sortType.category);
		setPref("moonfox.thread_tree_sort_direction", sortType.direction);
		setPref("moonfox.datatype_value", document.getElementById("rdogrp_datatype").value);
		
		if(mfObserver)
			mfObserver.stop();
		
		if(tagWindow && !tagWindow.closed)
			tagWindow.close();
	} catch(e) {
		alert(e);
	}
}

/*
 * フィルタに変化があった場合
 */
function filterChanged() {
	try {
		constructTree(true);
	} catch(e) {
		alert(e);
	}
}

/*
 *
 */
function goBackItemClicked() {
	try {
		var br = document.getElementById('browser_viewer');
		
		if(br.canGoBack) {
			br.goBack();
			closeBrowserMenu();
			
			var func = function() {
				if(br.contentTitle) {
					setShowingThreadTitle(br.contentTitle);
				}
			}
			setTimeout(func, 1000);
		}
	} catch(e) {
		alert(e);
	}
}

/*
 *
 */
function goForwardItemClicked() {
	try {
		var br = document.getElementById('browser_viewer');
		
		if(br.canGoForward) {
			br.goForward();
			closeBrowserMenu();
			
			var func = function() {
				if(br.contentTitle) {
					setShowingThreadTitle(br.contentTitle);
				}
			}
			setTimeout(func, 1000);
		}
	} catch(e) {
		alert(e);
	}
}

/**
 * 画像ビューア選択
 */
function imgviewerItemClicked() {
	try {
		if(winImageViewer && !winImageViewer.closed) {
			winImageViewer.focus();
		} else {
			winImageViewer = window.open("chrome://moonfox/content/imgviewer/imgviewer.xul"
											, "moonfox_imgviewer"
											, "width=850,height=650,modal=no,resizable=yes,status=no,toolbar=no");
		}
	} catch(e) {
		alert(e);
	}
}

/*
 * 「新しいタブで開く」の処理。
 */
function openThreadAtNewTabItemSelected(item) {
	try {
		var thinfoArray = getSelectedThreadList();
		
		if(thinfoArray.length > 0)
			showThreadAtNewTab(thinfoArray);
	} catch(e) {
		alert(e);
	}
}

/**
 * 
 */
function openThreadItemClicked() {
	try {
		var thinfoArray = getSelectedThreadList();
		
		if(thinfoArray.length > 0)
			showThread(thinfoArray);
	} catch(e) {
		alert(e);
	}
}

/**
 * 
 */
function openByThreadcgiItemClicked() {
	try {
		var thinfoArray = getSelectedThreadList();
		
		if(thinfoArray.length > 0)
			showThreadByThreadcgi(thinfoArray);
	} catch(e) {
		alert(e);
	}
}

/**
 * オプションメニューアイテム選択
 */
function optionItemClicked() {
	try {
		var ret = {ok:false}
		
		window.openDialog(
			"chrome://moonfox/content/option/option.xul",
			"moonfox_option",
			"modal=yes",
			ret);
		
		if(ret.ok)
			self.location.reload();	
	} catch(e) {
		alert(e);
	}
}

/*
 *
 */
function reloadItemClicked() {
	try {
		document.getElementById("browser_viewer").reload();
		closeBrowserMenu();
	} catch(e) {
		alert(e);
	}
}

/*
 * 初期処理を行います。
 */
function startup(event) {
	try{
		if(startflg)
			return;
		
		startflg = true;	
		tagManager = new TagManager();
		initMsg("chrome://moonfox/locale/messages.properties");
		
		//設定読込み
		autoUpdate = getPref("moonfox.auto_update");
		observeInterval = getPref("moonfox.observe_interval");
		sortType.category = getPref("moonfox.thread_tree_sort_category");
		sortType.direction = getPref("moonfox.thread_tree_sort_direction");
		document.getElementById("rdogrp_datatype").value = getPref("moonfox.datatype_value");
		
		if(getPref("moonfox.public_gateway_mode"))
			startPublicGatewayMode();
		
		initBrowserMenu();
		configDataTypeRadio();
		configThreadTreeHeader();
		constructTagCombo();
		
		if(observeInterval == 0)
			observeInterval = 5;
		
		//自動更新
		if(autoUpdate) {
			var milsec = observeInterval * 60 * 1000;
			//setInterval(fetchData, milsec);
			updateTimer = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
			updateTimer.initWithCallback(
							{
								notify: function(timer) {
											fetchData();
										}
							}
							, milsec
							, Components.interfaces.nsITimer.TYPE_REPEATING_SLACK);
			
		}
		
		//オブザーバースタート
		if(!public_gateway_mode) {
			mfObserver = new MoonfoxObserver();
		}
		
		fetchData();
	} catch(e) {
		alert(e);
	}
}

/*
 * タグが変更された場合の処理を行います。
 */
function tagChanged(combo) {
	try {
		constructTree(true);
	} catch(e) {
		alert(e);
	}
}

/*
 *
 */
function tagLabelClicked() {
	try{
		if(tagWindow && !tagWindow.closed) {
			tagWindow.focus();
			return;
		}
	
		var arg = {tagManager:null,func:null,clearFunc:null}
		arg.tagManager = tagManager;
		arg.func = receiveFromTagDialog;
		arg.clearFunc = clearTag;
		
		tagWindow = window.openDialog("chrome://moonfox/content/tagdialog/tagdialog.xul"
					, "moonfox_tag"
					, "modal=no,resizable=yes"
					, arg);

	} catch(e) {
		alert(e);
	}
}

/*
 * スレッドツリーがダブルクリックされた場合の処理を行います。
 */
function threadTreeDblClicked(event) {

	try{
		if(event.target.tagName == "treechildren" || event.target.tagName == "menuitem") {
			var thinfo = getSelectedThread();
			
			if(thinfo) {
				var thinfoList = [];
				thinfoList.push(thinfo);
				showThread(thinfoList);
			}
		}
	} catch(e) {
		alert(e);
	}
}
