/*
 * キャッシュディレクトリを選択。
 */
function chooseCacheDir() {
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"]
        .createInstance(nsIFilePicker);
	fp.init(window, "Select a cache directory", nsIFilePicker.modeGetFolder);
	
	var res = fp.show();
	if (res == nsIFilePicker.returnOK){
	  var file = new File(fp.file);
	  
	  document.getElementById("text_cache").value = file.getPath();
	}
}

/*
 * ログディレクトリを選択。
 */
function chooseLogDir() {
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"]
        .createInstance(nsIFilePicker);
	fp.init(window, "Select a Log directory", nsIFilePicker.modeGetFolder);
	
	var res = fp.show();
	if (res == nsIFilePicker.returnOK){
	  var file = new File(fp.file);
	  
	  document.getElementById("text_log").value = file.getPath();
	}
}

/*
 * OKボタン押下時
 */
function doOk() {
	var ok = false;
	
	try {
		//基本
		var host = document.getElementById("text_host").value;
		var port = document.getElementById("text_port").value;
		var path = document.getElementById("text_path").value;
		var cache = document.getElementById("text_cache").value;
		var log = document.getElementById("text_log").value;
		var pubgate = document.getElementById("public_gateway_mode").checked;
		var autoUpdate = document.getElementById("check_auto_update").checked;
		var interval = document.getElementById("text_observe_interval").value;
		
		//スレッド
		var unvisibleRemovalNotification = document.getElementById("check_unvisible_removal_notification").checked;
		var popupImageSize = document.getElementById("text_popup_imgsize").value;
		
		//画像
		var thumbNum = document.getElementById("text_max_thumb_per_page").value;
		var thumbMaxSize = document.getElementById("text_max_thumb_size").value;
		var onceLoadImageNum = document.getElementById("text_once_load_num").value;
		var loadAndShow = document.getElementById("chk_load_and_show").checked;
		
		setPref("moonfox.host", host);
		setPref("moonfox.port", port);
		setPref("moonfox.path", path);
		setPref("moonfox.cachedir", cache);
		setPref("moonfox.logdir", log);
		setPref("moonfox.public_gateway_mode", pubgate);
		setPref("moonfox.auto_update", autoUpdate);
		setPref("moonfox.observe_interval", interval);
		
		setPref("moonfox.thread.unvisible_removal_notification", unvisibleRemovalNotification);
		setPref("moonfox.thread.image_size", popupImageSize);
		
		setPref("moonfox.imgviewer.max_thumb_num_per_page", thumbNum);
		setPref("moonfox.imgviewer.max_thumbsize", thumbMaxSize);
		setPref("moonfox.imgviewer.once_load_num", onceLoadImageNum);
		setPref("moonfox.imgviewer.load_and_show", loadAndShow);
		
		if(window.arguments && window.arguments[0]) {
			window.arguments[0].ok = true;
		}
		
		ok = true;
	} catch(e) {
		errbox(e);
	}
	
	return ok;
}

/*
 * 初期処理
 */
function startup() {
	//一般
	var host = getPref("moonfox.host");
	var port = getPref("moonfox.port");
	var path = getPref("moonfox.path");
	var cache = getPref("moonfox.cachedir");
	var log = getPref("moonfox.logdir");
	var pubgate = getPref("moonfox.public_gateway_mode");
	var autoUpdate = getPref("moonfox.auto_update");
	var interval = getPref("moonfox.observe_interval");
	
	document.getElementById("text_host").value = host;
	document.getElementById("text_port").value = port;
	document.getElementById("text_path").value = path;
	document.getElementById("text_cache").value = cache;
	document.getElementById("text_log").value = log;
	document.getElementById("public_gateway_mode").checked = pubgate;
	document.getElementById("check_auto_update").checked = autoUpdate;
	document.getElementById("text_observe_interval").value = interval;
	
	//スレッド
	var unvisibleRemovalNotification = getPref("moonfox.thread.unvisible_removal_notification");
	var popupImageSize = getPref("moonfox.thread.image_size");
	
	document.getElementById("check_unvisible_removal_notification").checked = unvisibleRemovalNotification;
	document.getElementById("text_popup_imgsize").value = popupImageSize;
	
	//画像
	var thumbNum = getPref("moonfox.imgviewer.max_thumb_num_per_page");
	var thumbMaxSize = getPref("moonfox.imgviewer.max_thumbsize");
	var onceLoadedImageNum = getPref("moonfox.imgviewer.once_load_num");
	var loadAndShow = getPref("moonfox.imgviewer.load_and_show");
	
	document.getElementById("text_max_thumb_per_page").value = thumbNum;
	document.getElementById("text_max_thumb_size").value = thumbMaxSize;
	document.getElementById("text_once_load_num").value = onceLoadedImageNum;
	document.getElementById("chk_load_and_show").checked = loadAndShow;
}